-- CHANGES: added the faster attack speed
Hooks:PostHook(PlayerStandard, "_do_melee_damage", "faster_attack_speed", function(self, t, bayonet_melee, melee_hit_ray)
	log("nel posthook")
	if managers.player:has_category_upgrade("player", "attack_speed_multiplier") then
		log("nel primo if")
		local ats_mul = managers.player:upgrade_value("player", "attack_speed_multiplier", 1)
		if ats_mul > 1 then
			log("nel secondo if")
			log("ats_mul = ", ats_mul)
			local eq_melee = managers.blackmarket:equipped_melee_weapon()
			local _melee_tweak = tweak_data.blackmarket.melee_weapons[eq_melee]
			local uneq_delay = _melee_tweak.expire_t or 0
			local repeat_delay = _melee_tweak.repeat_expire_t or 0		
			local new_uneq_delay = uneq_delay / ats_mul
			local new_repeat_delay = repeat_delay / ats_mul
			
			if self._state_data.melee_expire_t then
				self._state_data.melee_expire_t = self._state_data.melee_expire_t - new_uneq_delay
			end
			
			if self._state_data.melee_repeat_expire_t then
				self._state_data.melee_repeat_expire_t = self._state_data.melee_repeat_expire_t - new_repeat_delay
			end
			
		end
	end
	
end )

-- CHANGES: added faster melee charge
function PlayerStandard:_get_melee_charge_lerp_value(t, offset)
    offset = offset or 0
    local melee_entry = managers.blackmarket:equipped_melee_weapon()
    local max_charge_time = tweak_data.blackmarket.melee_weapons[melee_entry].stats.charge_time

    
	if managers.player:has_category_upgrade("player", "melee_charge_speed_increase") then
	log("if check")
    max_charge_time = max_charge_time / managers.player:upgrade_value("player", "melee_charge_speed_increase", 1)
	log("charge speed", max_charge_time)
	end

    if not self._state_data.melee_start_t then
        return 0
    end

    return math.clamp(t - self._state_data.melee_start_t - offset, 0, max_charge_time) / max_charge_time
end

-- CHANGES: only higher swap speed will apply (needs OVERKILL ace to have passive_swap_speed_multiplier upgrade)
function PlayerStandard:_get_swap_speed_multiplier()
	local multiplier = 1
	local weapon_tweak_data = self._equipped_unit:base():weapon_tweak_data()

	local swap_mul = managers.player:upgrade_value("weapon", "swap_speed_multiplier", 1)
	log("swap_mul =", swap_mul)
	local passive_swap_mul = managers.player:upgrade_value("weapon", "passive_swap_speed_multiplier", 1)
	log("passive_swap_mul =", passive_swap_mul)
	
	multiplier = math.max(swap_mul, passive_swap_mul)
	log("multiplier = ", multiplier)
	--multiplier = multiplier * managers.player:upgrade_value("weapon", "swap_speed_multiplier", 1)
	--multiplier = multiplier * managers.player:upgrade_value("weapon", "passive_swap_speed_multiplier", 1)

	for _, category in ipairs(weapon_tweak_data.categories) do
		multiplier = multiplier * managers.player:upgrade_value(category, "swap_speed_multiplier", 1)
	end

	multiplier = multiplier * managers.player:upgrade_value("team", "crew_faster_swap", 1)

	if managers.player:has_activate_temporary_upgrade("temporary", "swap_weapon_faster") then
		multiplier = multiplier * managers.player:temporary_upgrade_value("temporary", "swap_weapon_faster", 1)
	end

	multiplier = managers.modifiers:modify_value("PlayerStandard:GetSwapSpeedMultiplier", multiplier)

	return multiplier
end
