Hooks:PostHook( UpgradesTweakData, "init", "EPE_upgrades", function(self, tweak_data)

	self.ecm_feedback_retrigger_interval = 150						
	

	
	-- self.revive_health_multiplier = {1.5}						-- combat medic ace
	
	-- prova
	self.values.player.power_crit = {1.5}							-- crit damage multiplier
	
	self.values.player.sheep_leader = {2}							-- you can move x extra hostages at a time
	-- fine prova
	
	self.values.player.automatic_faster_reload = {					-- check also in playermanager
		{
			min_reload_increase = 1.4,
			penalty = 0.98,
			target_enemies = 3,
			min_bullets = 20,
			max_reload_increase = 2
		}
	}
	
	self.values.player.regain_throwable_from_ammo = {				-- Fully loaded fixed
		{
			chance = 0.05,
			chance_inc = 0.01
		}
	}

	self.values.weapon.armor_piercing_chance_silencer = {1, 0.4}	-- silencer armor piercing chance (the second value shoudn't work and it's not used)
	self.values.player.dodge_to_heal = {0.04, 0.1}					--															lucky shot
	self.values.player.auto_gtfu_chance = {0.2, 0.45}				-- feign death auto revive
	self.values.player.auto_gtfu_increase = {0.1}					-- feign death increase chance
	self.values.shotgun.hip_rate_of_fire = {1.4}
	self.values.player.attack_speed_multiplier = {1.5}				-- you swing your melee weapons 50% faster					counterstrike basic
	self.values.player.melee_charge_speed_increase = {2}			-- you charge your melee weapons 100% faster				counterstrike
	self.values.player.downed_dmg_reduction = {0.6, 0.1}			-- you take 40% - 90% less damage while in bleedout			relentless
	self.values.player.weapon_accuracy_increase = {1, 4}
	self.values.player.stability_increase_bonus_1 = {1}
	self.values.player.stability_increase_bonus_2 = {3}	
	self.values.player.single_shot_accuracy_inc = {0.85}
	self.values.snp.fire_rate_multiplier = {1.5}
	self.values.snp.reload_speed_multiplier = {1.2}
	self.values.assault_rifle.reload_speed_multiplier = {1.2}
	self.values.smg.reload_speed_multiplier = {1.2}
	self.values.player.double_drop = {5}							-- 															scavenger ace
	self.values.player.bleed_out_time = {1.33} 						-- bleed out time multiplier
	self.values.player.revived_health_regain = {1.5}				-- you get revived with 50% more health (up you go)
	self.values.weapon.silencer_spread_index_addend = {1}			-- the professional
	self.values.weapon.silencer_recoil_index_addend = {1}			--  ''      '' 
    self.values.player.drill_speed_multiplier = {0.8, 0.5}			-- drill timers multipliers
	self.values.player.drill_autorepair_1 = {0.15}					-- autorestart chance 1 (hardware expert ace)
	self.values.player.drill_autorepair_2 = {0.25}					-- autorestart chance 2 (kickstarter basic)
	-- RIFLEMAN 	check! the following 3 values SHOULD give +12 accuracy while moving
	self.values.smg.move_spread_index_addend = {3}
	self.values.assault_rifle.move_spread_index_addend = {3}
	self.values.snp.move_spread_index_addend = {3}
	-- OVERKILL
	self.values.temporary.overkill_damage_multiplier = {
		{
			1.75,
			12
		}
	}
	self.values.shotgun.steelsight_accuracy_inc = {0.4}				-- far away accuracy bonus		- penso sia un moltiplicatore di penalità perché 0.4 -> 60%
	
	self.values.weapon.swap_speed_multiplier = {
		1.8,
		1.35
	}
	
	--[[ BURGLAR upgrades 
	
	self.values.player.armor_regen_timer_stand_still_multiplier = {
		0.8
	}
	self.values.player.tier_dodge_chance = {
		0.2,
		0.25,
		0.3
	}
	self.values.player.stand_still_crouch_camouflage_bonus = {
		0.9,
		0.85,
		0.8
	}
	self.values.player.corpse_dispose_speed_multiplier = {
		0.8
	}
	self.values.player.pick_lock_speed_multiplier = {
		0.8
	}
	self.values.player.alarm_pager_speed_multiplier = {
		0.9
	}
	]]
	
	--[[ UNSEEN STRIKE (one of the two... check upgradestweakdata)]]
	self.values.player.unseen_increased_crit_chance = {
		{
			min_time = 3,
			max_duration = 4,
			crit_chance = 1.4
		},
		{
			min_time = 3,
			max_duration = 12,
			crit_chance = 1.4
		}
	}
	self.values.temporary.unseen_strike = {
		{
			1.4,
			4
		},
		{
			1.4,
			12
		}
	}
	
	-- TRIGGER HAPPY
	self.values.pistol.stacking_hit_damage_multiplier = {
		{
			max_stacks = 2,
			max_time = 4,
			damage_bonus = 1.4
		},
		{
			max_stacks = 3,
			max_time = 4,
			damage_bonus = 1.4
		}
	}
	-- FORCED FRIENDSHIP
	self.values.team.damage = {
		hostage_absorption = {0.25},
		hostage_absorption_limit = 8
	}
	
	

	--[[ HEAVY IMPACT
	self.values.weapon.knock_down = {
		0.1,
		0.25
	}]]

	-- da capire cos'è: per ora è la damage reduction che hai quando rianimi qualcuno e/o quando vieni rianimato
	-- self.values.temporary.revive_damage_reduction = {{0, 120}}

	--[[ UP YOU GO - temporary revived damage resistance					--		- da capire
	self.values.temporary.revived_damage_resist = {
		{
			0,
			2
		}
	}]]
	
	-- SHOCKPROOF		da darci un'occhiata!!
	self.values.player.taser_malfunction = {
		{
			interval = 1.5,
			chance_to_trigger = 0.33
		},
		{
			interval = 1.5,
			chance_to_trigger = 1
		}
	}
	
	-- EXTRA HEADSHOT DAMAGE
	self.values.weapon.collector_headshot_multiplier = {
		1.35,
		1.25																-- not used at all
	}
	
	-- SNEAKY BASTARD
	self.values.player.detection_risk_add_dodge_chance = {
		{
			0.01,
			3,
			"below",
			35,
			0.1
		},
		{
			0.01,
			1,
			"below",
			35,
			0.15
		}
	}
	
	self.ammo_restore_armor_values = {										-- 
		{0.5},																-- this value is {armor_restored/10}
		{2}, 														
		cooldown = 2
	}
	
	-- DO NOT TOUCH!!
	self.values.temporary.ammo_restore_armor = {}
	
	for i, data in ipairs(self.ammo_restore_armor_values) do
		local base = self.ammo_restore_armor_values.base

		table.insert(self.values.temporary.ammo_restore_armor, {
			{data[1]},
			self.ammo_restore_armor_values.cooldown
		})
	end
	
	
	-- PAINKILLERS (possibili, da capire come)
	self.values.temporary.passive_revive_damage_reduction = {
		{
			0.85,
			10
		},
		{
			0.6,
			10
		}
	}
	self.values.player.revive_damage_reduction_level = {
		1,
		2
	}
	-- fine
	

	--  DEFINITIONS  --  DEFINITIONS  --  DEFINITIONS  --
	
	-- prova
	
	self.definitions.player_power_crit = {
		name_id = "menu_player_power_crit",
		category = "feature",
		upgrade = {
			value = 1,
			upgrade = "power_crit",
			category = "player"
		}
	}
	
	self.definitions.player_sheep_leader = {
		name_id = "menu_player_sheep_leader",
		category = "feature",
		upgrade = {
			value = 1,
			upgrade = "sheep_leader",
			category = "player"
		}
	}
	
	--[[self.definitions.player_taser_malfunction_1 = {
		name_id = "menu_player_taser_malfunction",
		category = "feature",
		upgrade = {
			value = 1,
			upgrade = "taser_malfunction",
			category = "player"
		}
	}

	self.definitions.player_taser_malfunction_2 = {
		name_id = "menu_player_taser_malfunction",
		category = "feature",
		upgrade = {
			value = 2,
			upgrade = "taser_malfunction",
			category = "player"
		}
	}]]
	
	self.definitions.weapon_swap_speed_multiplier_low = {			-- +35% swap speed multiplier. needs test for bugs
		name_id = "menu_weapon_swap_speed_multiplier",
		category = "feature",
		upgrade = {
			value = 2,
			upgrade = "swap_speed_multiplier",
			category = "weapon"
		}
	}
	
	-- fine prova
	
	self.definitions.player_auto_gtfu_chance_1 = {
		name_id = "menu_player_auto_gtfu_chance",
		category = "feature",
		upgrade = {
			value = 1,
			upgrade = "auto_gtfu_chance",
			category = "player"
		}
	}
	
	self.definitions.player_auto_gtfu_chance_2 = {
		name_id = "menu_player_auto_gtfu_chance",
		category = "feature",
		upgrade = {
			value = 2,
			upgrade = "auto_gtfu_chance",
			category = "player"
		}
	}
	
	self.definitions.player_auto_gtfu_increase = {
		name_id = "menu_player_auto_gtfu_increase",
		category = "feature",
		upgrade = {
			value = 1,
			upgrade = "auto_gtfu_increase",
			category = "player"
		}
	}

	self.definitions.player_attack_speed_multiplier = {
		name_id = "menu_player_attack_speed_multiplier",
		category = "feature",
		upgrade = {
			value = 1,
			upgrade = "attack_speed_multiplier",
			category = "player"
		}
	}	
	
	self.definitions.player_dodge_to_heal_1 = {
		name_id = "menu_player_dodge_to_heal",
		category = "feature",
		upgrade = {
			value = 1,
			upgrade = "dodge_to_heal",
			category = "player"
		}
	}
	
	self.definitions.player_dodge_to_heal_2 = {
		name_id = "menu_player_dodge_to_heal",
		category = "feature",
		upgrade = {
			value = 2,
			upgrade = "dodge_to_heal",
			category = "player"
		}
	}
	
	self.definitions.temporary_loose_ammo_restore_armor_1 = {
		name_id = "menu_temporary_loose_ammo_restore_armor",
		category = "temporary",
		upgrade = {
			value = 1,
			upgrade = "ammo_restore_armor",
			category = "temporary"
	}
}

	self.definitions.temporary_loose_ammo_restore_armor_2 = {
		name_id = "menu_temporary_loose_ammo_restore_armor",
		category = "temporary",
		upgrade = {
			value = 2,
			upgrade = "ammo_restore_armor",
			category = "temporary"
	}
}
	
	self.definitions.player_melee_charge_speed_increase = {
		name_id = "menu_player_melee_charge_speed_increase",
		category = "feature",
		upgrade = {
			value = 1,
			upgrade = "melee_charge_speed_increase",
			category = "player"
		}
	}
	
	self.definitions.player_downed_dmg_reduction_1 = {
		name_id = "menu_player_downed_dmg_reduction",
		category = "feature",
		upgrade = {
			value = 1,
			upgrade = "downed_dmg_reduction",
			category = "player"
		}
	}
	
	self.definitions.player_downed_dmg_reduction_2 = {
		name_id = "menu_player_downed_dmg_reduction",
		category = "feature",
		upgrade = {
			value = 2,
			upgrade = "downed_dmg_reduction",
			category = "player"
		}
	}
	
	self.definitions.player_weapon_accuracy_increase_2 = {
		name_id = "menu_player_weapon_accuracy_increase",
		category = "feature",
		upgrade = {
			value = 2,
			upgrade = "weapon_accuracy_increase",
			category = "player"
		}
	}
		
	self.definitions.sniper_fire_rate_multiplier = {
		name_id = "menu_sniper_fire_rate_multiplier",
		category = "feature",
		upgrade = {
			value = 1,
			upgrade = "fire_rate_multiplier",
			category = "snp"
		}
	}
	
	self.definitions.weapon_collector_headshot_multiplier_1 = {
		name_id = "menu_weapon_collector_headshot_multiplier",
		category = "feature",
		upgrade = {
			value = 1,
			upgrade = "collector_headshot_multiplier",
			category = "weapon"
		}
	}
	
	self.definitions.weapon_collector_headshot_multiplier_2 = {
		name_id = "menu_weapon_collector_headshot_multiplier",
		category = "feature",
		upgrade = {
			value = 2,
			upgrade = "collector_headshot_multiplier",
			category = "weapon"
		}
	}

end )